// Code generated by MockGen. DO NOT EDIT.
// Source: author.pb.go

// Package server_mocks is a generated GoMock package.
package server_mocks

import (
	x "go.appointy.com/book/pb/author"
	context "context"
	gomock "github.com/golang/mock/gomock"
	empty "github.com/golang/protobuf/ptypes/empty"
	grpc "google.golang.org/grpc"
	reflect "reflect"
)

// MockAuthorsClient is a mock of AuthorsClient interface
type MockAuthorsClient struct {
	ctrl     *gomock.Controller
	recorder *MockAuthorsClientMockRecorder
}

// MockAuthorsClientMockRecorder is the mock recorder for MockAuthorsClient
type MockAuthorsClientMockRecorder struct {
	mock *MockAuthorsClient
}

// NewMockAuthorsClient creates a new mock instance
func NewMockAuthorsClient(ctrl *gomock.Controller) *MockAuthorsClient {
	mock := &MockAuthorsClient{ctrl: ctrl}
	mock.recorder = &MockAuthorsClientMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use
func (m *MockAuthorsClient) EXPECT() *MockAuthorsClientMockRecorder {
	return m.recorder
}

// CreateAuthor mocks base method
func (m *MockAuthorsClient) CreateAuthor(ctx context.Context, in *x.CreateAuthorRequest, opts ...grpc.CallOption) (*x.Author, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, in}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "CreateAuthor", varargs...)
	ret0, _ := ret[0].(*x.Author)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CreateAuthor indicates an expected call of CreateAuthor
func (mr *MockAuthorsClientMockRecorder) CreateAuthor(ctx, in interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, in}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreateAuthor", reflect.TypeOf((*MockAuthorsClient)(nil).CreateAuthor), varargs...)
}

// GetAuthor mocks base method
func (m *MockAuthorsClient) GetAuthor(ctx context.Context, in *x.GetAuthorRequest, opts ...grpc.CallOption) (*x.Author, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, in}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "GetAuthor", varargs...)
	ret0, _ := ret[0].(*x.Author)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetAuthor indicates an expected call of GetAuthor
func (mr *MockAuthorsClientMockRecorder) GetAuthor(ctx, in interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, in}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetAuthor", reflect.TypeOf((*MockAuthorsClient)(nil).GetAuthor), varargs...)
}

// UpdateAuthor mocks base method
func (m *MockAuthorsClient) UpdateAuthor(ctx context.Context, in *x.UpdateAuthorRequest, opts ...grpc.CallOption) (*empty.Empty, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, in}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "UpdateAuthor", varargs...)
	ret0, _ := ret[0].(*empty.Empty)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// UpdateAuthor indicates an expected call of UpdateAuthor
func (mr *MockAuthorsClientMockRecorder) UpdateAuthor(ctx, in interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, in}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "UpdateAuthor", reflect.TypeOf((*MockAuthorsClient)(nil).UpdateAuthor), varargs...)
}

// DeleteAuthor mocks base method
func (m *MockAuthorsClient) DeleteAuthor(ctx context.Context, in *x.DeleteAuthorRequest, opts ...grpc.CallOption) (*empty.Empty, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, in}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "DeleteAuthor", varargs...)
	ret0, _ := ret[0].(*empty.Empty)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// DeleteAuthor indicates an expected call of DeleteAuthor
func (mr *MockAuthorsClientMockRecorder) DeleteAuthor(ctx, in interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, in}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "DeleteAuthor", reflect.TypeOf((*MockAuthorsClient)(nil).DeleteAuthor), varargs...)
}

// ListAuthor mocks base method
func (m *MockAuthorsClient) ListAuthor(ctx context.Context, in *x.ListAuthorsRequest, opts ...grpc.CallOption) (*x.ListAuthorsResponse, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, in}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "ListAuthor", varargs...)
	ret0, _ := ret[0].(*x.ListAuthorsResponse)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// ListAuthor indicates an expected call of ListAuthor
func (mr *MockAuthorsClientMockRecorder) ListAuthor(ctx, in interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, in}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ListAuthor", reflect.TypeOf((*MockAuthorsClient)(nil).ListAuthor), varargs...)
}

// MockAuthorsServer is a mock of AuthorsServer interface
type MockAuthorsServer struct {
	ctrl     *gomock.Controller
	recorder *MockAuthorsServerMockRecorder
}

// MockAuthorsServerMockRecorder is the mock recorder for MockAuthorsServer
type MockAuthorsServerMockRecorder struct {
	mock *MockAuthorsServer
}

// NewMockAuthorsServer creates a new mock instance
func NewMockAuthorsServer(ctrl *gomock.Controller) *MockAuthorsServer {
	mock := &MockAuthorsServer{ctrl: ctrl}
	mock.recorder = &MockAuthorsServerMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use
func (m *MockAuthorsServer) EXPECT() *MockAuthorsServerMockRecorder {
	return m.recorder
}

// CreateAuthor mocks base method
func (m *MockAuthorsServer) CreateAuthor(arg0 context.Context, arg1 *x.CreateAuthorRequest) (*x.Author, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CreateAuthor", arg0, arg1)
	ret0, _ := ret[0].(*x.Author)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CreateAuthor indicates an expected call of CreateAuthor
func (mr *MockAuthorsServerMockRecorder) CreateAuthor(arg0, arg1 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreateAuthor", reflect.TypeOf((*MockAuthorsServer)(nil).CreateAuthor), arg0, arg1)
}

// GetAuthor mocks base method
func (m *MockAuthorsServer) GetAuthor(arg0 context.Context, arg1 *x.GetAuthorRequest) (*x.Author, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetAuthor", arg0, arg1)
	ret0, _ := ret[0].(*x.Author)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetAuthor indicates an expected call of GetAuthor
func (mr *MockAuthorsServerMockRecorder) GetAuthor(arg0, arg1 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetAuthor", reflect.TypeOf((*MockAuthorsServer)(nil).GetAuthor), arg0, arg1)
}

// UpdateAuthor mocks base method
func (m *MockAuthorsServer) UpdateAuthor(arg0 context.Context, arg1 *x.UpdateAuthorRequest) (*empty.Empty, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "UpdateAuthor", arg0, arg1)
	ret0, _ := ret[0].(*empty.Empty)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// UpdateAuthor indicates an expected call of UpdateAuthor
func (mr *MockAuthorsServerMockRecorder) UpdateAuthor(arg0, arg1 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "UpdateAuthor", reflect.TypeOf((*MockAuthorsServer)(nil).UpdateAuthor), arg0, arg1)
}

// DeleteAuthor mocks base method
func (m *MockAuthorsServer) DeleteAuthor(arg0 context.Context, arg1 *x.DeleteAuthorRequest) (*empty.Empty, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "DeleteAuthor", arg0, arg1)
	ret0, _ := ret[0].(*empty.Empty)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// DeleteAuthor indicates an expected call of DeleteAuthor
func (mr *MockAuthorsServerMockRecorder) DeleteAuthor(arg0, arg1 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "DeleteAuthor", reflect.TypeOf((*MockAuthorsServer)(nil).DeleteAuthor), arg0, arg1)
}

// ListAuthor mocks base method
func (m *MockAuthorsServer) ListAuthor(arg0 context.Context, arg1 *x.ListAuthorsRequest) (*x.ListAuthorsResponse, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ListAuthor", arg0, arg1)
	ret0, _ := ret[0].(*x.ListAuthorsResponse)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// ListAuthor indicates an expected call of ListAuthor
func (mr *MockAuthorsServerMockRecorder) ListAuthor(arg0, arg1 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ListAuthor", reflect.TypeOf((*MockAuthorsServer)(nil).ListAuthor), arg0, arg1)
}
